#!/usr/bin/env python
"""
Author: Jun Ding
Date: NOV.3,2011
Version: 1.0
function: this code is used to obtained the score cutoff for given pwm under certain
occurence lambda.
usage: python.get_lambda.py <input_seq><motif><cutoff>
"""
def MotifScan1(seqs,mot,reg,bk):
	data=[0]*len(reg)
	minscore=reg[0]
	maxscore=reg[len(reg)-1]
	for seq in seqs:
		hit_position=[]
		if len(seq)-len(mot)>=0:
			for i in range(len(seq)-len(mot)+1):
				score_i=0
				for j in range(len(mot)):
					if seq[i+j]=='A':
						score_i=score_i+math.log(mot[j][0]/(bk[0]))
					elif seq[i+j]=='C':
						score_i=score_i+math.log(mot[j][1]/(bk[1]))
					elif seq[i+j]=='G':
						score_i=score_i+math.log(mot[j][2]/(bk[2]))
					elif seq[i+j]=='T':
						score_i=score_i+math.log(mot[j][3]/(bk[3]))
					else:
						score_i=score_i+0
				if (score_i<maxscore)&(score_i>minscore):
					tmp=(score_i-minscore)/0.0001
					tmp=math.floor(tmp)
				elif score_i<=minscore:
						tmp=0
				else:
					tmp=len(data)-1
				data[int(tmp)]+=1
		else:
			print('error! sequences is shorter than motif')
	return data

import pdb,sys,os,getopt
import math

opts,args=getopt.getopt(sys.argv[1:],"i:m:c:f:")
if len(opts)!=4:
	print ("python get_lambda -i <permuted_seq> -m <motifs> -c <cutoff> -f <motif_format>")
	sys.exit(0)

for i in opts:
	#pdb.set_trace()
	if i[0]=="-i":
		seqfile=i[1]
	if i[0]=="-m":
		motfile=i[1]
	if i[0]=="-c":
		cut=i[1]
	if i[0]=="-f":
		fm=i[1]

#read in input_SEQ
f=open(seqfile,'r')
lf=f.readlines()
f.close()
lf="".join(lf)
lf=lf.split(">")[1:]
lf=[item.split("\n") for item in lf]
lf=[[item[0],"".join(item[1:])] for item in lf]
seq=[item[1] for item in lf]
#pdb.set_trace()

#get length
sum_len=0
for i in range(len(seq)):
	sum_len+=len(seq[i])

#read in motifs
if fm=="0":
	f=open(motfile,'r')
	lf=f.readlines()
	f.close()
	lf=''.join(lf)
	lf=lf.split('>')[1:]
	lf=[item.split('\n')[:-2] for item in lf]
	motifs=[]
	# get lambda
elif fm=="1":
	f=open(motfile,'r')
	lf=f.readlines()
	lf="".join(lf)
	lf=lf.split("//\n")
	lf=[item for item in lf if item!=""]
	for i in range(len(lf)):
		lf[i]=lf[i].split("\n")
		IDi=lf[i][0].split()[1]
		lf[i]=lf[i][3:-2]
		for j in range(len(lf[i])):
			lf[i][j]=lf[i][j].split( )[1:-1]
			lf[i][j]=" ".join(lf[i][j])
		lf[i]=["M"+str(i)+"\t"+IDi]+lf[i]
	motifs=[]
		#pdb.set_trace()
else:
	print ("plese check your format id, it should be 0 or 1")

pcount=0.01
for i in lf:
	t=i[1:]
	t=[item.split(' ') for item in t]  ## note motif format
	for j in range(len(t)):
		t[j]=[float(item) for item in t[j]]
		t[j]=[item/sum(t[j]) for item in t[j]]
		t[j]=[item+pcount for item in t[j]]
		t[j]=[round(item/sum(t[j]),4) for item in t[j]]
	#pdb.set_trace()
	motifs.append(t)
MotifID=[item[0] for item in lf]
lam=[]
bk=[0,0,0,0]
# background freq in human
bk[0]=0.290763621993511
bk[1]=0.202156441211073
bk[2]=0.205656409776978
bk[3]=0.301423527018438

cutoff=float(cut)
print ("calculating for lambda...")
for i in range(len(motifs)):
	score_i=0
	num_i=0.0
	score_i2=0
	for j in range(len(motifs[i])):
		motifs[i][j]=[float(item) for item in motifs[i][j]]
		index_max=motifs[i][j].index(max(motifs[i][j]))
		score_i+=math.log(max(motifs[i][j])/bk[index_max])
		index_min=motifs[i][j].index(min(motifs[i][j]))
		score_i2+=math.log(min(motifs[i][j])/bk[index_max])
	max_score_i=score_i
	min_score_i=score_i2
	leng=max_score_i-min_score_i
	M=leng*10000
	M=int(M)
	reg=[]
	tmp=min_score_i
	reg.append(tmp)
	for nn in range(M):
		tmp=tmp+0.0001
		reg.append(tmp)
	
	data=MotifScan1(seq,motifs[i],reg,bk)
	num=0
	for kk in range(len(data)-1,0,-1):
		num+=data[kk]
		if num>(sum_len)*cutoff:
			break
	score_i=reg[kk]
	la_i=num*1.0/(sum_len)
	#print score_i,la_i
	
	print(i)
	lam.append(str(score_i)+'\t'+str(la_i))
	#pdb.set_trace()

## output motif matrix

for i in range(len(motifs)):
	for j in range(len(motifs[i])):
		motifs[i][j]=[str(item) for item in motifs[i][j]]
		motifs[i][j]=" ".join(motifs[i][j])
	motifs[i]="\n".join(motifs[i])
	MotifID[i]=MotifID[i].split("\t")
	lam[i]=lam[i].split("\t")
	motifs[i]=">"+MotifID[i][0]+"\t"+str(lam[i][0])+"\t"+"\t".join(MotifID[i][1:])+"\n"+motifs[i]+"\n"
motifs="\n".join(motifs)


for i in range(len(lam)):
	lam[i]=">"+MotifID[i][0]+"\t"+lam[i][1]+"\t"+MotifID[i][-1]
lam="\n".join(lam)

motfile=motfile.split('/')[-1]
f=open(motfile+'_lambda','w')
f.write(lam)
f.close()

f=open(motfile+'_pwm','w')
f.write(motifs)
f.close()	
	


